#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 OutputSize;
    vec4 OriginalSize;
    vec4 SourceSize;
    uint FrameCount;
} global;

layout(location = 0) in vec4 Position;
layout(location = 0) out vec2 vTexCoord;
layout(location = 1) in vec2 TexCoord;
layout(location = 1) out vec2 pix_no;
mat3 mix_mat;

void main()
{
    mix_mat = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 2.0, 0.0), vec3(0.0, 0.0, 2.0));
    gl_Position = global.MVP * Position;
    vTexCoord = TexCoord;
    pix_no = (TexCoord * global.SourceSize.xy) * (global.OutputSize.xy / global.SourceSize.xy);
}

